unit nblettre;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    VirguleBtn: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure VirguleBtnClick(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  public
  end;

var Form1: TForm1;

Implementation
{$R *.DFM}

uses Math;

{ ---------------------------------------------------------- }
function NbEnLettresInt(n: int64): string;
var d, n2 : int64;
    sflag : string;
const
  Chiffres : array[0..19] of string =
    ('' , 'un' , 'deux' , 'trois' , 'quatre' , 'cinq' , 'six' , 'sept' ,
    'huit' , 'neuf' , 'dix' , 'onze' , 'douze' , 'treize' ,
    'quatorze' , 'quinze' , 'seize' ,'dix-sept' , 'dix-huit' , 'dix-neuf');
  Dizaines : array[2..9] of string =
    ('vingt' , 'trente' , 'quarante' , 'cinquante' , 'soixante' , '' ,
    'quatre-vingt' , '');
  PuissancesMille : array[1..6] of string =
    ('mille', 'million', 'milliard', 'billion', 'billiard', 'trillion'); // etc...
begin
  CASE n of
    0..19:  result := Chiffres[n];  // fin
    20..69,80..89:
      if ((n mod 10 = 1) and (n<>81)) then
       result := Dizaines[n div 10] + ' et ' + NbEnLettresInt(n mod 10)
      else  // exception : on dit trente-et-un mais quatre-vingt un !
       result := Dizaines[n div 10] + ' ' + NbEnLettresInt(n mod 10);
    70..79,90..99:
      if (n = 71) then  // exception : 71 = 'soixante' et onze !
       result := Dizaines[n div 10 -1] + ' et ' + NbEnLettresInt(n mod 10 +10)
      else
       result := Dizaines[n div 10 -1] + ' ' + NbEnLettresInt(n mod 10 +10);
    100..999:
        if (n div 100 =1) then  // exception : un cent ne se dit pas !
          result := 'cent' + ' '+ NbEnLettresInt(n mod 100)
        else
        begin
          if (n mod 100)=0 then sflag := 's' else sflag := ''; // si pas reste !
         result := Chiffres[n div 100]+' '+'cent' +sflag+ ' '+ NbEnLettresInt(n mod 100);
        end;
    else
    begin
     // ex: 10^6 = 1M <=> exp (6 x ln(10) = 1M <=> 6 x ln(10) = ln (1M)
     //  <=> 6 = ln(1M) / ln(10) = Log10 (1M)
      d := trunc(log10(n)) div 3;   // arrondir puiss. 10
      n2 := trunc(power(10 , d * 3)); // vers groupe puissances de 1000 +proche
      if (trunc(log10(n))=3) and (trunc(n/1000)=1) then  // excep : un mille =bad !
        result := PuissancesMille[d] + ' ' + NbEnLettresInt(n mod n2)
      else
      begin
        if d=1 then sflag := '' else sflag := 's';  // s au pluriel sauf mille !
        result := NbEnLettresInt(n div n2) + ' ' + PuissancesMille[d]
          + sflag + ' ' + NbEnLettresInt(n mod n2);
      end;
    end;
  END; { case }
  //if result = '' then result := 'zero';
end;

{ ------------------------------------------------------------------ }
function NbEnLettres(value: Extended; removeDecimal: boolean = false): string;
// Fonction d'appel : en fait NbEnLettresInt = proc principale.
begin
  result := NbEnLettresInt(Trunc(Value));
  if not RemoveDecimal then
  if pos(',',form1.edit1.text)>0 then
    result := result + ' virgule ' +
      NbEnLettresInt(round(100 * frac(value)));
end;

{ --------------------Exemple -------------------------------- }
procedure TForm1.VirguleBtnClick(Sender: TObject);
begin
if edit1.text<>'' then
   edit2.Text:=NbEnLettres(strtofloat(Edit1.text),false);
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = $0D then
     if edit1.text<>'' then
        edit2.Text:=NbEnLettres(strtofloat(Edit1.text),false);
end;

end.

